<?php
/**
 * googlefroogle.php
 *
 * @package google froogle
 * @copyright Copyright 2003-2006 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: googlefroogle.php, v 1.3.3 07.02.2007 20:45 Andrew Berezin andrew@ecommerce-service.com$
 */
@define('GOOGLE_FROOGLE_VERSION', '1.3.3 07.02.2007 20:45');
/*
Google Base - Attribute List - http://base.google.co.uk/base/tab_instructions.html
Google Base - Products - Creating your bulk upload - http://base.google.com/base/products.html

TODO List
1. rss 2.0 format
2. Attribute support (http://base.google.com/base/products.html):
1) image_link. Support more pics.
2) payment_accepted
4) color (from products_attributes)
5) condition
6) delivery_notes
7) delivery_radius
9) format (from products_attributes)
10) manufacturer
11) manufacturer_id
12) model_number
13) payment_notes
14) pickup
16) shipping
17) size (from products_attributes)
18) tax_percent
19) tax_region
20) weight
*/
	require('includes/application_top.php');

	$stimer = microtime_float();

	@define('GOOGLE_FROOGLE_EXPIRATION_DAYS', 30);
	@define('GOOGLE_FROOGLE_EXPIRATION_BASE', 'now'); // now/product
	@define('GOOGLE_FROOGLE_OFFER_ID', 'id'); // id/model/false
	@define('GOOGLE_FROOGLE_DIRECTORY', 'feed/');
	@define('GOOGLE_FROOGLE_OUTPUT_BUFFER_MAXSIZE', 1024*1024);
	@define('GOOGLE_FROOGLE_CHECK_IMAGE', 'false');
	@define('GOOGLE_FROOGLE_STAT', false);

	@define('GOOGLE_FROOGLE_USE_CPATH', 'false');

	define('NL', "<br />\n");

	require(zen_get_file_directory(DIR_WS_LANGUAGES . $_SESSION['language'] .'/', 'googlefroogle.php', 'false'));

	$languages = $db->execute("select code, languages_id from " . TABLE_LANGUAGES . " where name='" . GOOGLE_FROOGLE_LANGUAGE . "' limit 1");

	$product_url_add = (GOOGLE_FROOGLE_LANGUAGE_DISPLAY == 'true' ? "&language=" . $languages->fields['code'] : '') . (GOOGLE_FROOGLE_CURRENCY_DISPLAY == 'true' ? "&currency=" . GOOGLE_FROOGLE_CURRENCY : '');

	echo TEXT_GOOGLE_FROOGLE_STARTED . NL;
	echo TEXT_GOOGLE_FROOGLE_FILE_LOCATION . DIR_FS_CATALOG . GOOGLE_FROOGLE_DIRECTORY . GOOGLE_FROOGLE_OUTPUT_FILENAME . NL;
	echo "Processing: Feed - " . (isset($_GET['feed']) && $_GET['feed'] == "yes" ? "Yes" : "No") . ", Upload - " . (isset($_GET['upload']) && $_GET['upload'] == "yes" ? "Yes" : "No") . NL;

if (isset($_GET['feed']) && $_GET['feed'] == "yes") {
	if (is_dir(DIR_FS_CATALOG . GOOGLE_FROOGLE_DIRECTORY)) {
		if (!is_writeable(DIR_FS_CATALOG . GOOGLE_FROOGLE_DIRECTORY)) {
			echo ERROR_GOOGLE_FROOGLE_DIRECTORY_NOT_WRITEABLE . NL;
			die;
		}
	} else {
		echo ERROR_GOOGLE_FROOGLE_DIRECTORY_DOES_NOT_EXIST . NL;
		die;
	}

	$stimer_feed = microtime_float();
	if (!get_cfg_var('safe_mode') && function_exists('safe_mode')) {
		set_time_limit(0);
	}

	$output_buffer = "";

	if(!zen_froogle_fwrite()) {
		echo ERROR_GOOGLE_FROOGLE_OPEN_FILE . NL;
		die;
	}

	$output = array();
	$output["title"] = "title";
	$output["description"] = "description";
	$output["link"] = "link";
	$output["price"] = "price";
	$output["image_link"] = "image_link";
	$output["expiration_date"] = "expiration_date";
	$output["label"] = "label";
	$output["id"] = "id";
	$output["brand"] = "brand";
	$output["product_type"] = "product_type";
	$output["condition"] = "condition";
	if(GOOGLE_FROOGLE_IN_STOCK == 'true') $output["quantity"] = "quantity";
	if(GOOGLE_FROOGLE_SHIPPING != '') $output["shipping"] = "shipping";
	if(GOOGLE_FROOGLE_LANGUAGE_DISPLAY == 'true') $output["language"] = "language";
	if(GOOGLE_FROOGLE_CURRENCY_DISPLAY == 'true') $output["currency"] = "currency";
	zen_froogle_fwrite($output);

	$categories_array = zen_froogle_category_tree();
	$products_query = "SELECT p.products_id, p.products_model, pd.products_name, pd.products_description, p.products_image, p.products_tax_class_id, p.products_price_sorter, GREATEST(p.products_date_added, p.products_last_modified, p.products_date_available) AS base_date, m.manufacturers_name, p.products_quantity, pt.type_handler
										 FROM " . TABLE_PRODUCTS . " p
											 LEFT JOIN " . TABLE_MANUFACTURERS . " m ON (p.manufacturers_id = m.manufacturers_id)
											 LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " pd ON (p.products_id = pd.products_id)
											 LEFT JOIN " . TABLE_PRODUCT_TYPES . " pt ON (p.products_type=pt.type_id)
										 WHERE p.products_status = 1
											 AND p.product_is_call = 0
											 AND p.product_is_free = 0
											 AND pd.language_id = " . $languages->fields['languages_id'] ."
										 ORDER BY p.products_id ASC";
//	$products_query = $db->bindVars($products_query, ':languageID', $languages->fields['languages_id'], 'integer');
	$products = $db->Execute($products_query);
	$tax_rate = array();
	while (!$products->EOF) {
		if(PROJECT_VERSION_MINOR < 3.6)
			$price = zen_get_products_actual_price($products->fields['products_id']);
		else
			$price = $products->fields['products_price_sorter'];
		if($price > 0) {
			if(!isset($tax_rate[$products->fields['products_tax_class_id']]))
				$tax_rate[$products->fields['products_tax_class_id']] = zen_get_tax_rate($products->fields['products_tax_class_id']);
			$price = zen_add_tax($price, $tax_rate[$products->fields['products_tax_class_id']]);
			$price = $currencies->value($price, true, GOOGLE_FROOGLE_CURRENCY, $currencies->get_value(GOOGLE_FROOGLE_CURRENCY));
			$href = ($products->fields['type_handler'] ? $products->fields['type_handler'] : 'product') . '_info';

			$output = array();
			$output["title"] = zen_froogle_sanita($products->fields['products_name'], true);
			$output["description"] = zen_froogle_sanita($products->fields['products_description']);
			$output["price"] = number_format($price, 2, '.', '');
			$output["image_link"] = zen_froogle_image_url($products->fields['products_image']);
			$output["expiration_date"] = zen_froogle_expiration_date($products->fields['base_date']);
			list($output["label"], $cPath) = zen_froogle_get_category($products->fields['products_id']);
			$cPath_href = (GOOGLE_FROOGLE_USE_CPATH == 'true' ? 'cPath=' . $cPath . '&' : '');
			$href = zen_href_link($href, $cPath_href . 'products_id=' . $products->fields['products_id'] . $product_url_add, 'NONSSL', false);
			$output["link"] = str_replace('&amp;', '&', $href);
			$output["id"] = (GOOGLE_FROOGLE_OFFER_ID == 'model' ? $products->fields['products_model'] : $products->fields['products_id']);
			$output["brand"] = zen_froogle_sanita($products->fields['manufacturers_name']);
			$output["product_type"] = GOOGLE_FROOGLE_PRODUCT_TYPE;
			$output["condition"] = GOOGLE_FROOGLE_CONDITION;
			$output["quantity"] = $products->fields['products_quantity'];
			$output["shipping"] = GOOGLE_FROOGLE_SHIPPING;
			$output["language"] = $languages->fields['code'];
			$output["currency"] = GOOGLE_FROOGLE_CURRENCY;
			zen_froogle_fwrite($output);
		}
		$products->MoveNext();
	}
	zen_froogle_fwrite();

	$timer_feed = microtime_float()-$stimer_feed;
	echo TEXT_GOOGLE_FROOGLE_FEED_COMPLETE . ' ' . GOOGLE_FROOGLE_TIME_TAKEN . ' ' . sprintf("%f " . TEXT_GOOGLE_FROOGLE_FEED_SECONDS, number_format($timer_feed, 6) ) . ' ' . $products->RecordCount() . TEXT_GOOGLE_FROOGLE_FEED_RECORDS . NL;
}

if (isset($_GET['upload']) && $_GET['upload'] == "yes") {
	echo TEXT_GOOGLE_FROOGLE_UPLOAD_STARTED . NL;
	if(ftp_file_upload(GOOGLE_FROOGLE_SERVER, GOOGLE_FROOGLE_USERNAME, GOOGLE_FROOGLE_PASSWORD, DIR_FS_CATALOG . GOOGLE_FROOGLE_DIRECTORY . GOOGLE_FROOGLE_OUTPUT_FILENAME)) {
		echo TEXT_GOOGLE_FROOGLE_UPLOAD_OK . NL;
		$db->execute("update " . TABLE_CONFIGURATION . " set configuration_value = '" . date("Y/m/d H:i:s") . "' where configuration_key='GOOGLE_FROOGLE_UPLOADED_DATE'");
	} else {
		echo TEXT_GOOGLE_FROOGLE_UPLOAD_FAILED . NL;
	}
}

	function zen_froogle_fwrite($output='') {
		static $fp = false;
		static $output_buffer = "";
		static $title_row = false;
		if($output == '') {
			if(!$fp) {
				$retval = $fp = fopen(DIR_FS_CATALOG . GOOGLE_FROOGLE_DIRECTORY . GOOGLE_FROOGLE_OUTPUT_FILENAME, "wb");
			} else {
				if(strlen($output_buffer) > 0) {
					$retval = fwrite($fp, $output_buffer, strlen($output_buffer));
					$output_buffer = "";
				}
				fclose($fp);
			}
		} else {
			if(!$title_row) {
				$title_row = $output;
			}
			$buf = array();
			foreach($title_row as $key=>$val) {
				$buf[] = (isset($output[$key]) ? $output[$key] : '');
			}
			$output = implode("\t", $buf);
			if(strlen($output_buffer) > GOOGLE_FROOGLE_OUTPUT_BUFFER_MAXSIZE) {
				$retval = fwrite($fp, $output_buffer, strlen($output_buffer));
				$output_buffer = "";
			}
			$output = rtrim($output) . "\n";
			if(strtolower(CHARSET) != 'utf-8')
				$output_buffer .= utf8_encode($output);
			else
				$output_buffer .= $output;
		}
		return $retval;
	}

	function zen_froogle_get_category($products_id) {
		global $categories_array, $db;
		static $p2c;
		if(!$p2c) {
			$q = $db->Execute("SELECT *
												FROM " . TABLE_PRODUCTS_TO_CATEGORIES);
			while (!$q->EOF) {
				if(!isset($p2c[$q->fields['products_id']]))
					$p2c[$q->fields['products_id']] = $q->fields['categories_id'];
				$q->MoveNext();
			}
		}
		if(isset($p2c[$products_id])) {
			$retval = $categories_array[$p2c[$products_id]]['name'];
//			var_dump($categories_array[$p2c[$products_id]]['cPath']);echo '<br />';
			$cPath = $categories_array[$p2c[$products_id]]['cPath'];
		} else {
			$cPath = $retval =  "";
		}
		return array($retval, $cPath);
	}

	function zen_froogle_category_tree($id_parent=0, $cPath='', $cName='', $cats=array()){
		global $db, $languages;
		$cat = $db->Execute("SELECT c.categories_id, c.parent_id, cd.categories_name
												 FROM " . TABLE_CATEGORIES . " c
													 LEFT JOIN " . TABLE_CATEGORIES_DESCRIPTION . " cd on c.categories_id = cd.categories_id
												 WHERE c.parent_id = '" . (int)$id_parent . "'
												 AND cd.language_id='" . (int)$languages->fields['languages_id'] . "'
												 AND c.categories_status= '1'",
												 '', false, 150);
		while (!$cat->EOF) {
			$cats[$cat->fields['categories_id']]['name'] = (zen_not_null($cName) ? $cName . ', ' : '') . zen_froogle_sanita($cat->fields['categories_name']);
			$cats[$cat->fields['categories_id']]['cPath'] = (zen_not_null($cPath) ? $cPath . '_' : '') . $cat->fields['categories_id'];
			if (zen_has_category_subcategories($cat->fields['categories_id'])) {
				$cats = zen_froogle_category_tree($cat->fields['categories_id'], $cats[$cat->fields['categories_id']]['cPath'], $cats[$cat->fields['categories_id']]['name'], $cats);
			}
			$cat->MoveNext();
		}
		return $cats;
	}

	function zen_froogle_sanita($str, $rt=false) {
		$str = strip_tags($str);
		$str = str_replace(array("\t" , "\n", "\r"), ' ', $str);
		$str = preg_replace('/\s\s+/', ' ', $str);
//	$str = str_replace(array("&reg;", "", "&copy;", "", "&trade;", ""), ' ', $str);
		$str = htmlentities(html_entity_decode($str));
		$in = $out = array();
		$in[] = "&reg;"; $out[] = '(r)';
		$in[] = "&copy;"; $out[] = '(c)';
		$in[] = "&trade;"; $out[] = '(tm)';
//		$str = str_replace($in, $out, $str);
		if($rt) $str = str_replace(array('>'), ' ', $str);
		$str = trim($str);
		return $str;
	}

	function zen_froogle_image_url($products_image) {
		if($products_image == "") return "";

		$products_image_extention = substr($products_image, strrpos($products_image, '.'));
		$products_image_base = ereg_replace($products_image_extention, '', $products_image);
		$products_image_medium = $products_image_base . IMAGE_SUFFIX_MEDIUM . $products_image_extention;
		$products_image_large = $products_image_base . IMAGE_SUFFIX_LARGE . $products_image_extention;

		// check for a medium image else use small
		if (!file_exists(DIR_WS_IMAGES . 'medium/' . $products_image_medium)) {
		  $products_image_medium = DIR_WS_IMAGES . $products_image;
		} else {
		  $products_image_medium = DIR_WS_IMAGES . 'medium/' . $products_image_medium;
		}
		// check for a large image else use medium else use small
		if (!file_exists(DIR_WS_IMAGES . 'large/' . $products_image_large)) {
		  if (!file_exists(DIR_WS_IMAGES . 'medium/' . $products_image_medium)) {
		    $products_image_large = DIR_WS_IMAGES . $products_image;
		  } else {
		    $products_image_large = DIR_WS_IMAGES . 'medium/' . $products_image_medium;
		  }
		} else {
		  $products_image_large = DIR_WS_IMAGES . 'large/' . $products_image_large;
		}
		if (function_exists('handle_image')) {
			$image_ih = handle_image($products_image_large, '', MEDIUM_IMAGE_WIDTH, MEDIUM_IMAGE_HEIGHT, ''); // medium should be enough, it is 150 x 120 while Google needs 90 x 90
			$retval = (HTTP_SERVER . DIR_WS_CATALOG . $image_ih[0]);
		} else {
			$retval = (HTTP_SERVER . DIR_WS_CATALOG . $products_image_large); // medium should be enough, it is 150 x 120 while Google needs 90 x 90
		}
		return $retval;
	}

	function zen_froogle_expiration_date($base_date) {
		if(GOOGLE_FROOGLE_EXPIRATION_BASE == 'now')
			$expiration_date = time();
		else
			$expiration_date = strtotime($base_date);
		$expiration_date += GOOGLE_FROOGLE_EXPIRATION_DAYS*24*60*60;
		$retval = (date('Y-m-d', $expiration_date));
		return $retval;
	}

	function ftp_file_upload($url, $login, $password, $local_file, $ftp_dir='', $ftp_file=false, $ssl=false, $ftp_mode=FTP_ASCII) {
		if(!is_callable('ftp_connect')) {
			echo FTP_FAILED . NL;
			return false;
		}
		if(!$ftp_file)
			$ftp_file = basename($local_file);
		ob_start();
		if($ssl)
			$cd = ftp_ssl_connect($url);
		else
			$cd = ftp_connect($url);
		if (!$cd) {
			$out = ftp_get_error_from_ob();
			echo FTP_CONNECTION_FAILED . ' ' . $url . NL;
			echo $out . NL;
			return false;
		}
		echo FTP_CONNECTION_OK . ' ' . $url . NL;
		$login_result = ftp_login($cd, $login, $password);
		if (!$login_result) {
			$out = ftp_get_error_from_ob();
//			echo FTP_LOGIN_FAILED . FTP_USERNAME . ' ' . $login . FTP_PASSWORD . ' ' . $password . NL;
			echo FTP_LOGIN_FAILED . NL;
			echo $out . NL;
			ftp_close($cd);
			return false;
		}
//		echo FTP_LOGIN_OK . FTP_USERNAME . ' ' . $login . FTP_PASSWORD . ' ' . $password . NL;
		echo FTP_LOGIN_OK . NL;
		if ($ftp_dir != "") {
			if (!ftp_chdir($cd, $ftp_dir)) {
				$out = ftp_get_error_from_ob();
				echo FTP_CANT_CHANGE_DIRECTORY . '&nbsp;' . $url . NL;
				echo $out . NL;
				ftp_close($cd);
				return false;
			}
		}
		echo FTP_CURRENT_DIRECTORY . '&nbsp;' . ftp_pwd($cd) . NL;
		ftp_pasv($cd, true);
		$upload = ftp_put($cd, $ftp_file, $local_file, $ftp_mode);
		$out = ftp_get_error_from_ob();
		$raw = ftp_rawlist($cd, $ftp_file, true);
		for($i=0,$n=sizeof($raw);$i<$n;$i++){
			$out .= $raw[$i] . '<br/>';
		}
		if (!$upload) {
			echo FTP_UPLOAD_FAILED . NL;
			if(isset($raw[0])) echo $raw[0] . NL;
			echo $out . NL;
			ftp_close($cd);
			return false;
		} else {
			echo FTP_UPLOAD_SUCCESS . NL;
			echo $raw[0] . NL;
			echo $out . NL;
		}
		ftp_close($cd);
		return true;
	}

	function ftp_get_error_from_ob() {
		$out = ob_get_contents();
		ob_end_clean();
		$out = str_replace(array('\\', '<!--error-->', '<br>', '<br />', "\n", 'in <b>'),array('/', '', '', '', '', ''),$out);
		if(strpos($out, DIR_FS_CATALOG) !== false){
			$out = substr($out, 0, strpos($out, DIR_FS_CATALOG));
		}
		return $out;
	}

function microtime_float() {
   list($usec, $sec) = explode(" ", microtime());
   return ((float)$usec + (float)$sec);
}
?>